// DiiTestDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DiiTest.h"
#include "DiiTestDlg.h"
#include "Shlwapi.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDiiTestDlg dialog

CDiiTestDlg::CDiiTestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDiiTestDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDiiTestDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDiiTestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDiiTestDlg)
	DDX_Control(pDX, IDC_INPUT_PORT, m_InputPortResult);
	DDX_Control(pDX, IDC_INPUT_PORT_VALUE, m_InPort);
	DDX_Control(pDX, IDC_OUTPUT_PORT_VALUE, m_OutPort);
	DDX_Control(pDX, IDC_OUTPUT_VALUE, m_OutputValue);
	DDX_Control(pDX, IDC_PORT_NUMBER2, m_InputPortNumber);
	DDX_Control(pDX, IDC_PORT_NUMBER, m_OutputPortNumber);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDiiTestDlg, CDialog)
	//{{AFX_MSG_MAP(CDiiTestDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_INPUT_PORT_VALUE, OnInputPortValue)
	ON_BN_CLICKED(IDC_OUTPUT_PORT_VALUE, OnOutputPortValue)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDiiTestDlg message handlers

BOOL CDiiTestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

	// Open the device and get device's handle
	m_hDevice = DiiOpenDevice (	1,			// Device ID : this version must be 1
								1,			// index of Device : this version must be 1
								FALSE );	// open exclusively: this version must be FALSE

	/*
	// You also can open the device via using DiiOpenNamedDevice function call
	// DiiOpenNamedDevice opens a device by it's name
	m_hDevice = DiiOpenNamedDevice (
									"PCI_IND",	// Device Name : this version must be "PCI_IND"
									FALSE );	// open exclusively : this version must be FALSE

	*/
	if(m_hDevice == INVALID_HANDLE_VALUE)
		OutputDebugString("Open Device Failure!!\n");

	m_InputPortNumber.SetCurSel(0);
	m_OutputPortNumber.SetCurSel(0);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CDiiTestDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDiiTestDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDiiTestDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CDiiTestDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	BOOL bResult = TRUE;
	if(m_hDevice != INVALID_HANDLE_VALUE)
		bResult = DiiCloseDevice(m_hDevice);
	
	if(!bResult)
		AfxMessageBox("Close Handle Failure!");

	CDialog::OnCancel();
}

void CDiiTestDlg::OnOK() 
{
	// TODO: Add extra validation here
	BOOL bResult = TRUE;
	if(m_hDevice != INVALID_HANDLE_VALUE)
		bResult = DiiCloseDevice(m_hDevice);
	
	if(!bResult)
		AfxMessageBox("Close Handle Failure!");

	CDialog::OnOK();
}

void CDiiTestDlg::OnInputPortValue() 
{
	// TODO: Add your control notification handler code here
	BOOL bResult = TRUE;
	DWORD dwPortNumber = 0;
	BYTE bResultValue;
	dwPortNumber = m_InputPortNumber.GetCurSel() + 1;
	bResult = DiiGetDigitalByte (
						m_hDevice,		// a handle of an Device previously opened
						dwPortNumber,	// the number of the port to read
						&bResultValue);	// points to the value read from the port
	
	if(bResult)
	{		
		CString str;
	    str.Format(_T("Port %d value : %d"), dwPortNumber, bResultValue);
		m_InputPortResult.AddString( str );

	}else
	{
		AfxMessageBox("Read Port Failure!");
	}
}

void CDiiTestDlg::OnOutputPortValue() 
{
	// TODO: Add your control notification handler code here
	BOOL bResult = TRUE;
	DWORD dwPortNumber = 0;
	BYTE bWriteValue;
	dwPortNumber = m_OutputPortNumber.GetCurSel() + 1;

	CString strNumber;
	
	m_OutputValue.GetWindowText(strNumber);
	bWriteValue = (BYTE)StrToInt( (LPCTSTR) strNumber);

	bResult = DiiSetDigitalByte (
						m_hDevice,		// a handle of an Device previously opened
						dwPortNumber,	// the number of the port to write
						bWriteValue);	// the value to write to the channel

	
	if(!bResult)
	{		
		AfxMessageBox("Write Port Failure!");
	}
}
